#!/usr/bin/perl
##
## pvm brute force password cracker
##	- jan 2004 - BeF <bef@erlangen.ccc.de>
##

use Parallel::Pvm;
require  $ENV{"HOME"} . "/pvm3/bin/" . $ENV{"PVM_ARCH"} . "/pwcrack-lib.pl";

$SLAVENAME="pwcrack-slave.pl";


select STDERR; $| = 1;      # make unbuffered
select STDOUT; $| = 1;      # make unbuffered

sub Error {
	my ($msg)=@_[0]; 
	print(STDERR "$msg\n");
	exit(1);
}

sub crack_remote
{
	my ($password, @tids) = @_;

	@pass_prefix = ();
	$pass_end = '';
	while(1) {
	
		## send password ranges
		for ($i = 0; $i <= $#tids; $i++) {
			$pass_start = $pass_end;
			@pass_prefix = &increment(@pass_prefix);
			$pass_end = join('', ($letters[0], $letters[0]), @pass_prefix);
			Parallel::Pvm::initsend;
			Parallel::Pvm::pack($pass_start);
			Parallel::Pvm::pack($pass_end);
			Parallel::Pvm::pack($password);
			print "sending $pass_start, $pass_end, $password to $tids[$i]...";
			Parallel::Pvm::send($tids[$i], 'T');
			print "done.\n"
		}
		
		## receive cracked password
		for ($i = 0; $i <= $#tids; $i++) {
			if ( Parallel::Pvm::recv(-1, 'R') >= 0 ) {
				$cracked = Parallel::Pvm::unpack;
				$slavetid = Parallel::Pvm::unpack;
				print "received message from tid $slavetid with message ($cracked)\n";
				if ($cracked ne '') { return $cracked; }
			}
		 }
		 
	}
}

sub Main {
	&Error("Usage: $0 <number of processes> <password hash>\n") if $#ARGV != 1;

	$nproc = @ARGV[0];
	$password = @ARGV[1];

	$mytid = Parallel::Pvm::mytid;

	## spawn slaves
	($numt,@tids) = Parallel::Pvm::spawn($SLAVENAME,$nproc);

	## error handling
	if ($numt < $nproc) {
		printf("\n Trouble spawning slaves. Aborting. Error codes are:\n");
		for($i = $numt; $i < $nproc; $i++) { 
			printf("TID %d %d\n", $i, @tids[$i]); 
		}
		for($i = 0; $i < $numt; $i++) {
			Parallel::Pvm::kill(@tids[$i]); 
		}
		Parallel::Pvm::exit;
		exit(1);
	}
	


	## send/receive
	$cracked = crack_remote($password, @tids);
	print "cracked password ($password) is ($cracked)\n";



	# kill all remained slaves
	for ($i = 0; $i < $nproc; $i++)
	{
	  Parallel::Pvm::kill(@tids[$i]);
	}

	Parallel::Pvm::exit;
	return 0;
}

&Main;

